Loading...
Searching...
No Matches
elements.h File Reference
`#include <libxml/xmlreader.h>`
`#include <libxml/xmlwriter.h>`
`#include <stdbool.h>`
`#include <time.h>`
`#include "public/oscap.h"`
`#include "util.h"`
Include dependency graph for common/elements.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros

#define | OSCAP_XMLNS_XSI BAD_CAST "http://www.w3.org/2001/XMLSchema-instance"

## Typedefs

typedef void(* | oscap_xml_value_consumer) (char *, void *)

## Functions

int | oscap_parser_text_value (xmlTextReaderPtr reader, oscap_xml_value_consumer consumer, void *user)
void | oscap_text_consumer (char *text, void *user)
bool | oscap_to_start_element (xmlTextReaderPtr reader, int depth)
| find starting element at given depth (returns false if none found)
char * | oscap_element_string_copy (xmlTextReaderPtr reader)
| get a copy of a string contained by current element
const char * | oscap_element_string_get (xmlTextReaderPtr reader)
| get a string contained by current element
int | oscap_element_depth (xmlTextReaderPtr reader)
| get depth of current element
char * | oscap_get_xml (xmlTextReaderPtr reader)
| get xml content of current element as a string
time_t | oscap_get_date (const char *date)
| get date from a string
time_t | oscap_get_datetime (const char *date)
| get datetime from a string
xmlNode * | oscap_xmlstr_to_dom (xmlNode *parent, const char *elname, const char *content)
| convert a piece of XML string to DOM
int | oscap_xml_save_filename (const char *filename, xmlDocPtr doc)
| Save XML Document to the file of the given filename.
int | oscap_xml_save_fd (int fd, xmlDocPtr doc)
| Save XML Document to the given file descriptor.
int | oscap_xml_save_filename_free (const char *filename, xmlDocPtr doc)
| Save XML Document to the file of the given filename and dispose the document afterwards.
xmlNs * | lookup_xsi_ns (xmlDoc *doc)

## Variables

const struct oscap_string_map | OSCAP_BOOL_MAP []
| boolean to string (and vice versa) conversion map

## Function Documentation

## oscap_xml_save_fd()

int oscap_xml_save_fd | ( | int | fd,
|  | xmlDocPtr | doc )

Save XML Document to the given file descriptor.

The file descriptor isn't closed by this function.

Parameters

  fd | file descriptor
  doc | the XML document content

Returns
  1 on success, -1 on failure (oscap_seterr is set appropriately).

## oscap_xml_save_filename()

int oscap_xml_save_filename | ( | const char * | filename,
|  | xmlDocPtr | doc )

Save XML Document to the file of the given filename.

Parameters

  filename | path to the file
  doc | the XML document content

Returns
  1 on success, -1 on failure (oscap_seterr is set appropriately).

## oscap_xml_save_filename_free()

int oscap_xml_save_filename_free | ( | const char * | filename,
|  | xmlDocPtr | doc )

Save XML Document to the file of the given filename and dispose the document afterwards.

Parameters

  filename | path to the file
  doc | the XML document content

Returns
  1 on success, -1 on failure (oscap_seterr is set appropriatly).